org.jfree.data.statistics

## Class DefaultStatisticalCategoryDataset

- java.lang.Object
- - org.jfree.data.general.AbstractDataset
  - - org.jfree.data.statistics.DefaultStatisticalCategoryDataset

All Implemented Interfaces:
  java.io.ObjectInputValidation, java.io.Serializable, java.lang.Cloneable, CategoryDataset, Dataset, KeyedValues2D, RangeInfo, StatisticalCategoryDataset, Values2D, org.jfree.util.PublicCloneable

    public class DefaultStatisticalCategoryDataset
    extends AbstractDataset
    implements StatisticalCategoryDataset, RangeInfo, org.jfree.util.PublicCloneable

A convenience class that provides a default implementation of the `StatisticalCategoryDataset` interface.

See Also:
  Serialized Form

### Constructor Summary

Constructors
Constructor and Description
`DefaultStatisticalCategoryDataset()` Creates a new dataset.

### Method Summary

Methods
`void` `add(double mean, double standardDeviation, java.lang.Comparable rowKey, java.lang.Comparable columnKey)` Adds a mean and standard deviation to the table.
`void` `add(java.lang.Number mean, java.lang.Number standardDeviation, java.lang.Comparable rowKey, java.lang.Comparable columnKey)` Adds a mean and standard deviation to the table.
`void` `clear()` Clears all data from the dataset and sends a `DatasetChangeEvent` to all registered listeners.
`java.lang.Object` `clone()` Returns a clone of this dataset.
`boolean` `equals(java.lang.Object obj)` Tests this instance for equality with an arbitrary object.
`int` `getColumnCount()` Returns the number of columns in the table.
`int` `getColumnIndex(java.lang.Comparable key)` Returns the column index for a given key.
`java.lang.Comparable` `getColumnKey(int column)` Returns a column key.
`java.util.List` `getColumnKeys()` Returns the column keys.
`java.lang.Number` `getMeanValue(java.lang.Comparable rowKey, java.lang.Comparable columnKey)` Returns the mean value for an item.
`java.lang.Number` `getMeanValue(int row, int column)` Returns the mean value for an item.
`Range` `getRangeBounds(boolean includeInterval)` Returns the bounds of the values in this dataset's y-values.
`double` `getRangeLowerBound(boolean includeInterval)` Returns the minimum y-value in the dataset.
`double` `getRangeUpperBound(boolean includeInterval)` Returns the maximum y-value in the dataset.
`int` `getRowCount()` Returns the number of rows in the table.
`int` `getRowIndex(java.lang.Comparable key)` Returns the row index for a given key.
`java.lang.Comparable` `getRowKey(int row)` Returns a row key.
`java.util.List` `getRowKeys()` Returns the row keys.
`java.lang.Number` `getStdDevValue(java.lang.Comparable rowKey, java.lang.Comparable columnKey)` Returns the standard deviation value for an item.
`java.lang.Number` `getStdDevValue(int row, int column)` Returns the standard deviation value for an item.
`java.lang.Number` `getValue(java.lang.Comparable rowKey, java.lang.Comparable columnKey)` Returns the value for an item (for this dataset, the mean value is returned).
`java.lang.Number` `getValue(int row, int column)` Returns the value for an item (for this dataset, the mean value is returned).
`void` `remove(java.lang.Comparable rowKey, java.lang.Comparable columnKey)` Removes an item from the dataset and sends a `DatasetChangeEvent` to all registered listeners.
`void` `removeColumn(java.lang.Comparable columnKey)` Removes a column from the dataset and sends a `DatasetChangeEvent` to all registered listeners.
`void` `removeColumn(int columnIndex)` Removes a column from the dataset and sends a `DatasetChangeEvent` to all registered listeners.
`void` `removeRow(java.lang.Comparable rowKey)` Removes a row from the dataset and sends a `DatasetChangeEvent` to all registered listeners.
`void` `removeRow(int rowIndex)` Removes a row from the dataset and sends a `DatasetChangeEvent` to all registered listeners.

### Methods inherited from class org.jfree.data.general.AbstractDataset

`addChangeListener, fireDatasetChanged, getGroup, hasListener, notifyListeners, removeChangeListener, setGroup, validateObject`

### Methods inherited from class java.lang.Object

`finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.jfree.data.general.Dataset

`addChangeListener, getGroup, removeChangeListener, setGroup`

### Constructor Detail

#### DefaultStatisticalCategoryDataset

    public DefaultStatisticalCategoryDataset()

Creates a new dataset.

### Method Detail

#### getMeanValue

    public java.lang.Number getMeanValue(int row,
                                int column)

Returns the mean value for an item.

Specified by:
  `getMeanValue` in interface `StatisticalCategoryDataset`
Parameters:
  `row` - the row index (zero-based).
  `column` - the column index (zero-based).
Returns:
  The mean value (possibly `null`).

#### getValue

    public java.lang.Number getValue(int row,
                            int column)

Returns the value for an item (for this dataset, the mean value is returned).

Specified by:
  `getValue` in interface `Values2D`
Parameters:
  `row` - the row index.
  `column` - the column index.
Returns:
  The value (possibly `null`).

#### getValue

    public java.lang.Number getValue(java.lang.Comparable rowKey,
                            java.lang.Comparable columnKey)

Returns the value for an item (for this dataset, the mean value is returned).

Specified by:
  `getValue` in interface `KeyedValues2D`
Parameters:
  `rowKey` - the row key.
  `columnKey` - the columnKey.
Returns:
  The value (possibly `null`).

#### getMeanValue

    public java.lang.Number getMeanValue(java.lang.Comparable rowKey,
                                java.lang.Comparable columnKey)

Returns the mean value for an item.

Specified by:
  `getMeanValue` in interface `StatisticalCategoryDataset`
Parameters:
  `rowKey` - the row key.
  `columnKey` - the columnKey.
Returns:
  The mean value (possibly `null`).

#### getStdDevValue

    public java.lang.Number getStdDevValue(int row,
                                  int column)

Returns the standard deviation value for an item.

Specified by:
  `getStdDevValue` in interface `StatisticalCategoryDataset`
Parameters:
  `row` - the row index (zero-based).
  `column` - the column index (zero-based).
Returns:
  The standard deviation (possibly `null`).

#### getStdDevValue

    public java.lang.Number getStdDevValue(java.lang.Comparable rowKey,
                                  java.lang.Comparable columnKey)

Returns the standard deviation value for an item.

Specified by:
  `getStdDevValue` in interface `StatisticalCategoryDataset`
Parameters:
  `rowKey` - the row key.
  `columnKey` - the columnKey.
Returns:
  The standard deviation (possibly `null`).

#### getColumnIndex

    public int getColumnIndex(java.lang.Comparable key)

Returns the column index for a given key.

Specified by:
  `getColumnIndex` in interface `KeyedValues2D`
Parameters:
  `key` - the column key (`null` not permitted).
Returns:
  The column index.

#### getColumnKey

    public java.lang.Comparable getColumnKey(int column)

Returns a column key.

Specified by:
  `getColumnKey` in interface `KeyedValues2D`
Parameters:
  `column` - the column index (zero-based).
Returns:
  The column key.

#### getColumnKeys

    public java.util.List getColumnKeys()

Returns the column keys.

Specified by:
  `getColumnKeys` in interface `KeyedValues2D`
Returns:
  The keys.

#### getRowIndex

    public int getRowIndex(java.lang.Comparable key)

Returns the row index for a given key.

Specified by:
  `getRowIndex` in interface `KeyedValues2D`
Parameters:
  `key` - the row key (`null` not permitted).
Returns:
  The row index.

#### getRowKey

    public java.lang.Comparable getRowKey(int row)

Returns a row key.

Specified by:
  `getRowKey` in interface `KeyedValues2D`
Parameters:
  `row` - the row index (zero-based).
Returns:
  The row key.

#### getRowKeys

    public java.util.List getRowKeys()

Returns the row keys.

Specified by:
  `getRowKeys` in interface `KeyedValues2D`
Returns:
  The keys.

#### getRowCount

    public int getRowCount()

Returns the number of rows in the table.

Specified by:
  `getRowCount` in interface `Values2D`
Returns:
  The row count.
See Also:
  `getColumnCount()`

#### getColumnCount

    public int getColumnCount()

Returns the number of columns in the table.

Specified by:
  `getColumnCount` in interface `Values2D`
Returns:
  The column count.
See Also:
  `getRowCount()`

#### add

    public void add(double mean,
           double standardDeviation,
           java.lang.Comparable rowKey,
           java.lang.Comparable columnKey)

Adds a mean and standard deviation to the table.

Parameters:
  `mean` - the mean.
  `standardDeviation` - the standard deviation.
  `rowKey` - the row key.
  `columnKey` - the column key.

#### add

    public void add(java.lang.Number mean,
           java.lang.Number standardDeviation,
           java.lang.Comparable rowKey,
           java.lang.Comparable columnKey)

Adds a mean and standard deviation to the table.

Parameters:
  `mean` - the mean.
  `standardDeviation` - the standard deviation.
  `rowKey` - the row key.
  `columnKey` - the column key.

#### remove

    public void remove(java.lang.Comparable rowKey,
              java.lang.Comparable columnKey)

Removes an item from the dataset and sends a `DatasetChangeEvent` to all registered listeners.

Parameters:
  `rowKey` - the row key (`null` not permitted).
  `columnKey` - the column key (`null` not permitted).
Since:
  1.0.7
See Also:
  `add(double, double, Comparable, Comparable)`

#### removeRow

    public void removeRow(int rowIndex)

Removes a row from the dataset and sends a `DatasetChangeEvent` to all registered listeners.

Parameters:
  `rowIndex` - the row index.
Since:
  1.0.7
See Also:
  `removeColumn(int)`

#### removeRow

    public void removeRow(java.lang.Comparable rowKey)

Removes a row from the dataset and sends a `DatasetChangeEvent` to all registered listeners.

Parameters:
  `rowKey` - the row key (`null` not permitted).
Since:
  1.0.7
See Also:
  `removeColumn(Comparable)`

#### removeColumn

    public void removeColumn(int columnIndex)

Removes a column from the dataset and sends a `DatasetChangeEvent` to all registered listeners.

Parameters:
  `columnIndex` - the column index.
Since:
  1.0.7
See Also:
  `removeRow(int)`

#### removeColumn

    public void removeColumn(java.lang.Comparable columnKey)

Removes a column from the dataset and sends a `DatasetChangeEvent` to all registered listeners.

Parameters:
  `columnKey` - the column key (`null` not permitted).
Since:
  1.0.7
See Also:
  `removeRow(Comparable)`

#### clear

    public void clear()

Clears all data from the dataset and sends a `DatasetChangeEvent` to all registered listeners.

Since:
  1.0.7

#### getRangeLowerBound

    public double getRangeLowerBound(boolean includeInterval)

Returns the minimum y-value in the dataset.

Specified by:
  `getRangeLowerBound` in interface `RangeInfo`
Parameters:
  `includeInterval` - a flag that determines whether or not the y-interval is taken into account.
Returns:
  The minimum value.
See Also:
  `getRangeUpperBound(boolean)`

#### getRangeUpperBound

    public double getRangeUpperBound(boolean includeInterval)

Returns the maximum y-value in the dataset.

Specified by:
  `getRangeUpperBound` in interface `RangeInfo`
Parameters:
  `includeInterval` - a flag that determines whether or not the y-interval is taken into account.
Returns:
  The maximum value.
See Also:
  `getRangeLowerBound(boolean)`

#### getRangeBounds

    public Range getRangeBounds(boolean includeInterval)

Returns the bounds of the values in this dataset's y-values.

Specified by:
  `getRangeBounds` in interface `RangeInfo`
Parameters:
  `includeInterval` - a flag that determines whether or not the y-interval is taken into account.
Returns:
  The range.

#### equals

    public boolean equals(java.lang.Object obj)

Tests this instance for equality with an arbitrary object.

Overrides:
  `equals` in class `java.lang.Object`
Parameters:
  `obj` - the object (`null` permitted).
Returns:
  A boolean.

#### clone

    public java.lang.Object clone()
                           throws java.lang.CloneNotSupportedException

Returns a clone of this dataset.

Specified by:
  `clone` in interface `org.jfree.util.PublicCloneable`
Overrides:
  `clone` in class `AbstractDataset`
Returns:
  A clone of this dataset.
Throws:
  `java.lang.CloneNotSupportedException` - if cloning cannot be completed.